unit fgvau1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const a = 70;  tol=0; ig=2*pi;   finomsag=0.01;
      nezopont = 200;  alfa=pi/120; beta=pi/60;

Var
              Form1  : TForm1 ;
             xk, yk  : integer;
             xt, yt  : Integer;
  t,nv1,nv2,ap,bp,cp : Real;

Implementation

{$R *.DFM}

Function fx(t: real): real;
begin
 fx:=a*(cos(t)-sin(2*t));
end;

Function fy(t: real): real;
begin
 fy:=a*(cos(t)-sin(t));
end;

Function fz(t: real): real;
begin
 fz:=a*sin(3*t);
end;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
   xk:=ClientWidth  div 2;
   yk:=ClientHeight div 2;
   ap:=1;  bp:=1;   cp:=1;
End;

Procedure Vetit(x,y,z : real);
  begin
    xt:=xk+round((-bp*x+ap*y)/nv1);
    yt:=yk-round((-cp*(ap*x+bp*y)+sqr(nv1)*z)/nv2);
  end;

Procedure TForm1.FormPaint(Sender: TObject);
Var ik,iv:real;
begin
  nv1:=sqrt(sqr(ap)+sqr(bp));    nv2 := nv1 * sqrt(sqr(nv1)+sqr(cp));
  Canvas.TextOut(xk+round(-bp*200/nv1),yk-round(-cp*ap*200/nv2),'X');
  Canvas.TextOut(xk+round(ap*200/nv1),yk-round(-cp*bp*200/nv2), 'Y');
  Canvas.pen.color:=clBlue; Canvas.TextOut(xk,yk-round(sqr(nv1)*200/nv2),'Z');
  Canvas.MoveTo(xk,yk); Canvas.LineTo(xk+round( -bp*200/nv1),yk-round(-cp*ap*200/nv2));
  Canvas.MoveTo(xk,yk); Canvas.LineTo(xk+round( ap*200/nv1),yk-round( -cp*bp*200/nv2));
  Canvas.MoveTo(xk,yk); Canvas.LineTo(xk,yk-round(sqr(nv1)*200/nv2));
  Canvas.pen.color:=clBlack;
  t:=tol;
  Vetit(Fx(t),Fy(t),Fz(t));
  Canvas.MoveTo(xt,yt);
    While t<ig do
      begin
        Vetit(Fx(t),Fy(t),Fz(t));
        Canvas.LineTo(xt,yt);
        t:=t+finomsag;
      end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
     var au, bu, cu, r: real;
begin
    r:=sqrt(sqr(ap)+sqr(bp));
    case Key of
    'z':  begin
           au:=ap*cos(beta)+ap*cp/r*sin(beta);
           bu:=bp*cos(beta)+bp*cp/r*sin(beta);
           cu:=cp*cos(beta)-r*sin(beta);
         end;
    'w': begin
           au:=ap*cos(beta)-ap*cp/r*sin(beta);
           bu:=bp*cos(beta)-bp*cp/r*sin(beta);
           cu:=cp*cos(beta)+r*sin(beta);
         end;
    's': begin
           au:=ap*cos(alfa)+bp*sin(alfa);
           bu:=-ap*sin(alfa)+bp*cos(alfa);
           cu:=cp;
         end;
    'a':begin
           au:=ap*cos(alfa)-bp*sin(alfa);
           bu:=ap*sin(alfa)+bp*cos(alfa);
           cu:=cp;
         end;
    end;
    if (au*ap>0) or (bu*bp>0) then begin
                                     ap:=au; bp:=bu; cp:=cu;
                                   end;
Refresh;
end;

END.

