(*---------------------------------Prog.Hu----------------------------------*)
Program Kocka1;

Uses Crt,Graph;

Const M=350;
      p=350*65536;

Type
     T3D=record
              x,y,z : longint;
         end;
     TPoint=record
                  map : T3D;
                  coords : T3D;
                  screen : record
                                 a : byte;
                                 x,y : integer;
                           end;
                  normal : T3D;
                  newnormal : T3D;
            end;
     TPoly=record
                 pointnum : byte;
                 points : array[1..4] of word;
                 normal : T3D;
                 newnormal : T3D;
           end;
     T3DCube=record
                 points : array[1..8] of TPoint;
                 polys : array[1..6] of TPoly;
             end;
Var
    a,b       : integer;
    pointnum  : word;
    Cube      : T3DCube;
    sint,cost : Array[0..511] of integer;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Procedure InitCube;
begin
     {pontok megadasa 65536-al felszorozva}
     Cube.points[1].map.x:=-50*65536;
     Cube.points[1].map.y:=50*65536 ;
     Cube.points[1].map.z:=50*65536 ;

     Cube.points[2].map.x:=50*65536 ;
     Cube.points[2].map.y:=50*65536 ;
     Cube.points[2].map.z:=50*65536 ;

     Cube.points[3].map.x:=-50*65536 ;
     Cube.points[3].map.y:=-50*65536;
     Cube.points[3].map.z:=50*65536 ;

     Cube.points[4].map.x:=-50*65536;
     Cube.points[4].map.y:= 50*65536;
     Cube.points[4].map.z:=-50*65536;

     Cube.points[5].map.x:=50*65536 ;
     Cube.points[5].map.y:=50*65536 ;
     Cube.points[5].map.z:=-50*65536;

     Cube.points[6].map.x:=50*65536 ;
     Cube.points[6].map.y:=-50*65536;
     Cube.points[6].map.z:=-50*65536;

     Cube.points[7].map.x:=-50*65536;
     Cube.points[7].map.y:=-50*65536;
     Cube.points[7].map.z:=-50*65536;

     Cube.points[8].map.x:= 50*65536;
     Cube.points[8].map.y:=-50*65536;
     Cube.points[8].map.z:= 50*65536;
     Pointnum:=8;
end;

Procedure Ment;
 var
  f : file;
  c : word;
begin
   InitCube;
    assign(f,'kocka.3d');
    rewrite(f);
    blockwrite(f,pointnum,2);
    for c:=1 to pointnum do blockwrite(f,cube.points[c].map,sizeof(T3D));
    close(f);
end;

Procedure Tolt;
 var
  f : file;
  c : word;
begin
    assign(f,'kocka.3d');
    reset(f);
    blockread(f,pointnum,2);
    for c:=1 to pointnum do blockread(f,cube.points[c].map,sizeof(T3D));
    close(f);
end;

Procedure FillTabs;
var i: integer;
begin
     for i:=0 to 511 do
     begin
          sint[i]:=round(sin(i*2*pi/511)*256);
          cost[i]:=round(cos(i*2*pi/511)*256);
     end;
end;

Procedure Rotate;
var psa,pca,psb,pcb,pcs,pss,pcc,psc : longint;
    i : integer;
begin
 psa:=sint[a];
 pca:=cost[a];
 psb:=sint[b];
 pcb:=cost[b];
 pcs:=(pca*psb) div 256;
 pss:=(psa*psb) div 256;
 pcc:=(pca*pcb) div 256;
 psc:=(psa*pcb) div 256;

 with Cube do
 begin
  for i:=1 to pointnum do
  begin
   {koordinatak forgatasa}
   Points[i].coords.X:=(-Points[i].map.X*psa+Points[i].map.Y*pca) div 256;
   Points[i].coords.Y:=(-Points[i].map.X*pcs-Points[i].map.Y*pss+Points[i].map.Z*pcb) div 256;
   Points[i].coords.Z:=(-Points[i].map.X*pcc-Points[i].map.Y*psc-Points[i].map.Z*psb) div 256;

   {lekepezes}
   Points[i].screen.X:=longint(320)+((M*(Points[i].coords.X div 256)) div ((P+Points[i].coords.Z) div 256));
   Points[i].screen.Y:=longint(200)+((M*(Points[i].coords.Y div 256)) div ((P+Points[i].coords.Z) div 256));
  end;

 end;
end;

Procedure VerticalRetrace;        {Megvrja amg a VGA vgez az egsz}
Begin                             {kperny frisstsvel, ettl lesz}
  ASM                             {a mozgs szp folyamatos.         }
    MOV DX,$3da
 @1: IN AL,DX
     TEST AL,8
    JZ @1
  END;
End;

Procedure DrawPontok;
var i,p : integer;
begin
for i:=1 to 8 do putpixel(Cube.Points[i].screen.X, Cube.Points[i].screen.y,15);
VerticalRetrace; Delay(10);
for i:=1 to 8 do putpixel(Cube.Points[i].screen.X, Cube.Points[i].screen.y,0);
end;

Begin
      VideoInit;
      FillTabs;Ment;
      Repeat
            Rotate;
            DrawPontok;
            a:=(a+1) and 511;
            b:=(b+2) and 511;
      Until KeyPressed;
      Readkey;
Closegraph;
End.