Program TerGorbe;

Uses Crt,Graph;

Const a = 70; tol=0; ig=2*pi; finomsag=0.01;
      nezopont = 200;  alfa=pi/120; beta=pi/60;
Var
               xt, yt : Integer;
   t,nv1,nv2,ap,bp,cp : Real;
                   Ch : Char;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Function fx(t: real): real;
begin
 fx:=a*(cos(t)-sin(2*t));
end;

Function fy(t: real): real;
begin
 fy:=a*(cos(t)-sin(t));
end;

Function fz(t: real): real;
begin
 fz:=a*sin(3*t);
end;

Procedure Vetit(x,y,z : real);
  begin
    xt:=320+round((-bp*x+ap*y)/nv1);
    yt:=240-round((-cp*(ap*x+bp*y)+sqr(nv1)*z)/nv2);
  end;

Procedure TerGorRajz;
begin
                   ClearDevice; SetLineStyle(0,0,1); SetColor(14);
  nv1:=sqrt(sqr(ap)+sqr(bp)); nv2 := nv1 * sqrt(sqr(nv1)+sqr(cp));
  OutTextXY(318+round(-bp*200/nv1),238-round(-cp*ap*200/nv2),'X');
  OutTextXY(318+round(ap*200/nv1),238-round(-cp*bp*200/nv2), 'Y');
                   OutTextXY(318,238-round(sqr(nv1)*200/nv2),'Z');
  Line(320,240,320+round( -bp*200/nv1),240-round(-cp*ap*200/nv2));
  Line(320,240,320+round( ap*200/nv1),240-round( -cp*bp*200/nv2));
                    Line(320,240,320,240-round(sqr(nv1)*200/nv2));
  t:=tol;     SetColor(15);
  Vetit(Fx(t),Fy(t),Fz(t));
  MoveTo(xt,yt);
    While t<ig do
      begin
        Vetit(Fx(t),Fy(t),Fz(t));
             SetLineStyle(0,0,3);
                   LineTo(xt,yt);
        t:=t+finomsag;
      end;
end;

Procedure Forgat;
var au, bu, cu, r: real;
begin
    r:=sqrt(sqr(ap)+sqr(bp));
    case ch of
    #80:  begin
           au:=ap*cos(beta)+ap*cp/r*sin(beta);
           bu:=bp*cos(beta)+bp*cp/r*sin(beta);
           cu:=cp*cos(beta)-r*sin(beta);
         end;
    #72: begin
           au:=ap*cos(beta)-ap*cp/r*sin(beta);
           bu:=bp*cos(beta)-bp*cp/r*sin(beta);
           cu:=cp*cos(beta)+r*sin(beta);
         end;
    #75: begin
           au:=ap*cos(alfa)+bp*sin(alfa);
           bu:=-ap*sin(alfa)+bp*cos(alfa);
           cu:=cp;
         end;
    #77:begin
           au:=ap*cos(alfa)-bp*sin(alfa);
           bu:=ap*sin(alfa)+bp*cos(alfa);
           cu:=cp;
         end;
    end;
    if (au*ap>0) or (bu*bp>0) then begin
                                     ap:=au; bp:=bu; cp:=cu;
                                   end;
end;

Procedure ForgatasRajz;
begin
 Repeat
    Repeat
      ch:=readkey;
    Until (ch=#72) or (ch=#80) or (ch=#77) or (ch=#75) or (ord(ch)=27);
     Forgat;
     If ch<>chr(27) then TerGorRajz;
  Until ch=chr(27);
end;

Begin
 ap:=1;
 bp:=1;
 cp:=1;
 VideoInit;
 TerGorRajz;
 ForgatasRajz;
End. of program