Program TerGorbe;

Uses Crt,Graph;

Const a = 70; tol=0; ig=2*pi; finomsag=0.01;
      nezopont = 200;
Var
   xt, yt : Integer;
   t      : Real;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Function fx(t: real): real;
begin
 fx:=a*(cos(t)-sin(2*t));
end;

Function fy(t: real): real;
begin
 fy:=a*(cos(t)-sin(t));
end;

Function fz(t: real): real;
begin
 fz:=a*sin(3*t);
end;

Procedure Vetit(x,y,z : real);
  begin
        xt:=320+round( x * nezopont/(nezopont-z));
        yt:=240+round( y * nezopont/(nezopont-z));
  end;

Procedure TerGorRajz;
begin
     t:=tol;    SetColor(red);
     Vetit(Fx(t),Fy(t),Fz(t));
     MoveTo(xt,yt);
    while t<ig do
      begin
        Vetit(Fx(t),Fy(t),Fz(t));
        LineTo(xt,yt);
        t:=t+finomsag;
      end;
    Readkey;
end;

Begin
 VideoInit ;
 TerGorRajz;
End. of program