unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Const
       pn = 4;
    scale = 20;
   PontSz = 80;
  nezopont= 90000;
    fszog = pi/180;

Type
  pont3D = record
                  X,Y,Z : real;
           end;

  Tkep  = record
                  X,Y   : integer;
          end;

Var
   Form1: TForm1;
   kp,ep    : Array[1..pn] of Pont3D;
   kpoints  : Array[1..pn] of Tkep  ;
   k0       : real   ;
   ch,c     : char   ;
   k,i      : word   ;
   ks       : string ;
   xt, yt   : integer;
   Xk, Yk   : Integer;

Implementation

{$R *.DFM}

Procedure ErintoSz; {Erinto szamitas}
begin
  case ch of
  'N':begin {nylt grbe esetre}
          ep[1].x:=round( (kp[2].x-kp[1].x )*k0);
          ep[1].y:=round( (kp[2].y-kp[1].y )*k0);
          ep[1].z:=round( (kp[2].z-kp[1].z )*k0);

       ep[pn].x:=round((kp[pn].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[pn].y-kp[pn-1].y)*k0);
       ep[pn].z:=round((kp[pn].z-kp[pn-1].z)*k0);
      end;
  'Z':begin {zrt grbe esetre}
          ep[1].x:=round((kp[2].x-kp[pn].x)*k0);
          ep[1].y:=round((kp[2].y-kp[pn].y)*k0);
          ep[1].z:=round((kp[2].z-kp[pn].z)*k0);
       ep[pn].x:=round((kp[1].x-kp[pn-1].x)*k0);
       ep[pn].y:=round((kp[1].y-kp[pn-1].y)*k0);
       ep[pn].z:=round((kp[1].z-kp[pn-1].z)*k0);
      end;
  end;

  for k:=2 to pn-1 do begin  {mindkt grbe esetn ugyan az}
                       ep[k].x:=round((kp[k+1].x-kp[k-1].x)*k0);
                       ep[k].y:=round((kp[k+1].y-kp[k-1].y)*k0);
                       ep[k].z:=round((kp[k+1].z-kp[k-1].z)*k0);
                      end;
end;
Procedure TForm1.FormCreate(Sender: TObject);
Begin
   // Ltrehozzuk az alapbra pontjait
   xk:=ClientWidth  div 2;
   yk:=ClientHeight div 2;
           Ch:='N'; k0:=1;
   kp[1].x:=1 ; kp[1].y:=2 ; kp[1].z:=-5;
   kp[2].x:=1 ; kp[2].y:=2 ; kp[2].z:=-3;
   kp[3].x:=-7; kp[3].y:=1 ; kp[3].z:=-1;
   kp[4].x:=-2; kp[4].y:=5 ; kp[4].z:= 4;
                                ErintoSz;
End;

procedure vetit(x,y,z: real);
    {kpskravetts s kpernykoordintk kiszmtsa}
begin
        xt:=xk+round((x * nezopont)/(nezopont-z));
        yt:=yk-round((y * nezopont)/(nezopont-z));
end;

Procedure RotateX;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
      kp[i].y :=  kp[i].y * cos(fszog) + kp[i].z * sin(fszog);
      kp[i].z := -kp[i].y * sin(fszog) + kp[i].z * cos(fszog);
  end;
end;

Procedure RotateY;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
       kp[i].x := kp[i].x * cos(fszog) - kp[i].z * sin(fszog);
       kp[i].z := kp[i].x * sin(fszog) + kp[i].z * cos(fszog);
  end;
end;

Procedure RotateZ;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    kp[i].x :=  kp[i].x * cos(fszog) - kp[i].y * sin(fszog);
    kp[i].y :=  kp[i].x * sin(fszog) + kp[i].y * cos(fszog);
  end;
end;

Var
  j: integer;
  n, n2, n3 : real;

function xp(i, j: integer): integer; {grbepont x koordintja}
begin
  case ch of
  'N':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        xp:=round(((2*n3-3*n2+1)*kp[pn].x+(-2*n3+3*n2)*kp[1].x+
                   (n3-2*n2+n)*ep[pn].x+(n3-n2)*ep[1].x)*scale)
      else
        xp:=round(((2*n3-3*n2+1)*kp[i].x+(-2*n3+3*n2)*kp[i+1].x+
                  (n3-2*n2+n)*ep[i].x+(n3-n2)*ep[i+1].x)*scale);
    end;
  end;
end;

function yp(i, j: integer): integer; {grbepont y koordintja}
begin
  case ch of
  'N':begin
     n:=j/PontSz; n2:=n*n; n3:=n2*n;
     yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
               (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        yp:=round(((2*n3-3*n2+1)*kp[pn].y+(-2*n3+3*n2)*kp[1].y+
                   (n3-2*n2+n)*ep[pn].y+(n3-n2)*ep[1].y)*scale)
      else
        yp:=round(((2*n3-3*n2+1)*kp[i].y+(-2*n3+3*n2)*kp[i+1].y+
                  (n3-2*n2+n)*ep[i].y+(n3-n2)*ep[i+1].y)*scale);
    end;
  end;
end;

function zp(i, j: integer): integer; {grbepont x koordintja}
begin
  case ch of
  'N':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      zp:=round(((2*n3-3*n2+1)*kp[i].z+(-2*n3+3*n2)*kp[i+1].z+
                (n3-2*n2+n)*ep[i].z+(n3-n2)*ep[i+1].z)*scale);
    end;
  'Z':begin
      n:=j/PontSz; n2:=n*n; n3:=n2*n;
      if i=pn then
        zp:=round(((2*n3-3*n2+1)*kp[pn].z+(-2*n3+3*n2)*kp[1].z+
                   (n3-2*n2+n)*ep[pn].z+(n3-n2)*ep[1].z)*scale)
      else
        zp:=round(((2*n3-3*n2+1)*kp[i].z+(-2*n3+3*n2)*kp[i+1].z+
                  (n3-2*n2+n)*ep[i].z+(n3-n2)*ep[i+1].z)*scale);
    end;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
          case Key of
            'x' : RotateX;
            'y' : RotateY;
            'z' : RotateZ;
            'n' : ch:='N';
            'm' : ch:='Z';
         end;
Refresh;
end;

Procedure TForm1.FormPaint(Sender: TObject);
Var i : word;
Begin
 Canvas.pen.Color:=clBlue;
 if ch='N' then begin
                  vetit(xp(1,0),yp(1,0),zp(1,0));
                  Canvas.Moveto(xt,yt);
                end;

  if ch='Z' then begin
                  Vetit(xp(1,0),yp(1,0),zp(1,0));
                  Canvas.Moveto(xt,yt);
                 end;

  for i:=1 to pn-1 do for j:=1 to PontSz do begin
                                              Vetit(xp(i,j),yp(i,j),zp(i,j));
                                              Canvas.LineTo(xt,yt);
                                            end;

  if ch='Z' then      for j:=1 to PontSz do begin
                                              Vetit(xp(pn,j),yp(pn,j),zp(pn,j));
                                              Canvas.Lineto(xt,yt);
                                            end;
  For i:=1 to pn do begin
                    Vetit(kp[i].x*20,kp[i].y*20,kp[i].z*20);
                    Canvas.Ellipse(xt-4,yt-4,xt+5,yt+5);
                    end;
End;

END.
