Program Forgat1; {Point Rotatio}

Uses Graph;

Var x,y,z,xt,yt,zt : real;
    xan,yan,zan    : real;
    kx,ky,sx,sy    : integer;

Function ReadKey:Char; Assembler;
 asm
       xor ah,ah
       int 16h
 end;

Procedure VideoInit;
Var
  hibakod,gd,gm : integer;
  begin
   gd:=detect;
   InitGraph(gd,gm,'') ;
   hibakod:=graphresult;
   if hibakod<>0 then begin
                        writeln('Grafikus hiba: ',GraphErrorMsg(hibakod));
                        halt(1);
                      end;
   end;

Procedure Delay(ms : Word); Assembler;
asm
  mov ax, 1000;
  mul ms;
  mov cx, dx;
  mov dx, ax;
  mov ah, $86;
  int $15;
end;

Function Keypressed:Boolean;   Assembler;
asm
 mov  ah, 01h  {Get keyboard satus}
 int  16h      {Meghivjuk a BIOS megszakitst}
 mov  al,00h   {00h, azaz FALS}
 jz   @exit
 inc  al       {01h, azaz TRUE}
@exit:         {Visszaadjuk az AL regiszter rtkt}
end;

Begin
VideoInit;
Zan :=  0.3; {angle for rotation about Z axis}
Yan :=  0.1; {angle for rotation about Y axis}
Xan :=  0.1; {angle for rotation about X axis}

x:=20;  {coord of point on X axis}
y:=40;  {coord of point on Y axis}
z:=40;  {coord of point on Z axis}

Repeat
 PutPixel(SX,SY,0);
  Yt:= Y * COS(Xan) - Z * SIN(Xan); {calculates position after rotating}
  Zt:= Y * SIN(Xan) + Z * COS(Xan); {about the X axis}
  Y:= Yt;
  Z:= Zt;
  Xt:= X * COS(Yan) - Z * SIN(Xan); { '  ' about Y axis}
  Zt:= X * SIN(Yan) + Z * COS(Xan);
  X:= Xt;
  Z:= Zt;
  Xt:= X * COS(Zan) - Y * SIN(Zan); { '  ' about Z axis}
  Yt:= X * SIN(Zan) + Y * COS(Zan);
  X:= Xt;
  Y:= Yt;
  sx:=round(x)+320;   {converts REAL to INTEGER,}
  sy:=round(y)+200;   {320,200 is the centre of the screen}

  PutPixel(SX,SY,15); {draws the point}
  Delay(200);

Until KeyPressed;
CloseGraph;
End. of program
