Program Kocka2;

Uses Graph,Crt;

Const pn=8;
      pszog=pi/6;{45 fok radianban}
      nezopont=200;

Type  T3D=record
              x,y,z : real;
         end;
      T2D=record
              x,y:integer;
         end;

Var fszog:real;
    c    :char;
    points :Array[1..pn] of T3D; {az objektum pontjai}
    kpoints:Array[1..pn] of T2D; {3d->2d projekciobol kovetkezo kepkoordinatak}

Procedure InitCube;
begin
  points[1].x := -50;
  points[1].y :=  50;
  points[1].z :=  50;

  points[2].x :=  50;
  points[2].y :=  50;
  points[2].z :=  50;

  points[3].x := -50;
  points[3].y := -50;
  points[3].z :=  50;

  points[4].x := -50;
  points[4].y :=  50;
  points[4].z := -50;

  points[5].x :=  50;
  points[5].y :=  50;
  points[5].z := -50;

  points[6].x :=  50;
  points[6].y := -50;
  points[6].z := -50;

  points[7].x := -50;
  points[7].y := -50;
  points[7].z := -50;

  points[8].x :=  50;
  points[8].y := -50;
  points[8].z :=  50;
end;

Procedure VideoInit;
  var hibakod,gdriver,gmode:integer;
  begin
  gdriver:=detect;
  initgraph(gdriver,gmode,'');
  hibakod:=graphresult;
  if hibakod<>0 then
    begin
      writeln('GRAFIKUS HIBA: ',grapherrormsg(hibakod));
      halt(1);
    end;
  end;

Procedure Centralis_projekcio;
  var i:byte;
  begin
    for i:=1 to pn do
      begin
        kpoints[i].x:=320+round(points[i].x * nezopont/(nezopont-points[i].z));
        kpoints[i].y:=240+round(points[i].y * nezopont/(nezopont-points[i].z));
      end;
  end;

Procedure Perspektivikus_projekcio;
var
  i:byte;
begin
    for i:=1 to pn do
      begin
        kpoints[i].x:=320+round(points[i].X*cos(pszog) + points[i].Y*cos(pszog));
        kpoints[i].y:=240+round(points[i].X*sin(pszog) - points[i].Y*sin(pszog) - points[i].Z);
      end;
end;

Procedure DrawCube;
begin
 Line(kpoints[1].x,kpoints[1].y,kpoints[2].x,kpoints[2].y);
 Line(kpoints[2].x,kpoints[2].y,kpoints[5].x,kpoints[5].y);
 Line(kpoints[5].x,kpoints[5].y,kpoints[4].x,kpoints[4].y);
 Line(kpoints[4].x,kpoints[4].y,kpoints[1].x,kpoints[1].y);

 Line(kpoints[7].x,kpoints[7].y,kpoints[6].x,kpoints[6].y);
 Line(kpoints[6].x,kpoints[6].y,kpoints[8].x,kpoints[8].y);
 Line(kpoints[8].x,kpoints[8].y,kpoints[3].x,kpoints[3].y);
 Line(kpoints[3].x,kpoints[3].y,kpoints[7].x,kpoints[7].y);

 Line(kpoints[4].x,kpoints[4].y,kpoints[7].x,kpoints[7].y);
 Line(kpoints[1].x,kpoints[1].y,kpoints[3].x,kpoints[3].y);
 Line(kpoints[2].x,kpoints[2].y,kpoints[8].x,kpoints[8].y);
 Line(kpoints[5].x,kpoints[5].y,kpoints[6].x,kpoints[6].y);
end;

Procedure RotateX;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x :=  points[i].x;
    points[i].y :=  points[i].y * cos(fszog) + points[i].z * sin(fszog);
    points[i].z := -points[i].y * sin(fszog) + points[i].z * cos(fszog);
  end;
end;

Procedure RotateY;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x := points[i].x * cos(fszog) - points[i].z * sin(fszog);
    points[i].y := points[i].y;
    points[i].z := points[i].x * sin(fszog) + points[i].z * cos(fszog);
  end;
end;

Procedure RotateZ;
var
  i : integer;
begin
  for i := 1 to pn do
  begin
    points[i].x :=  points[i].x * cos(fszog) - points[i].y * sin(fszog);
    points[i].y :=  points[i].x * sin(fszog) + points[i].y * cos(fszog);
    points[i].z :=  points[i].z;
  end;
end;

Begin
  VideoInit;
   InitCube;
   fszog:=pi/180;
  Repeat
    Perspektivikus_projekcio;
     (*Centralis_projekcio*);
        DrawCube;
    c := readkey;
    if (c=#13) then fszog:=-fszog;
    case c of
      'x' : RotateX;
      'y' : RotateY;
      'z' : RotateZ;
    end;
   SetColor( 0);
       DrawCube;
   SetColor(15);
  Until c = #27;
     CloseGraph;
End. of program